package com.wgh.servlet;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import java.io.InputStream;
import java.util.*;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;

/**
 * 
 * @author administrator
 */
public class UpLoad extends HttpServlet {

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws ServletException, IOException {
		String action = request.getParameter("action");
		if ("uploadFile".equals(action)) {
			this.uploadFile(request, response); // ϴļ
		}
	}

	public void uploadFile(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html;charset=GBK");
		request.setCharacterEncoding("GBK");
		HttpSession session = request.getSession();
		session.setAttribute("progressBar", 0); // ָϴȵSession
		String error = "";
		int maxSize = 50 * 1024 * 1024; // ϴļС
		DiskFileItemFactory factory = new DiskFileItemFactory(); // ڴļĿһ
		ServletFileUpload upload = new ServletFileUpload(factory); // һµļϴ
		try {
			List items = upload.parseRequest(request);// ϴ
			Iterator itr = items.iterator();// öٷ
			while (itr.hasNext()) {
				FileItem item = (FileItem) itr.next(); // ȡFileItem
				if (!item.isFormField()) {// жǷΪļ
					if (item.getName() != null && !item.getName().equals("")) {// жǷѡļ
						long upFileSize = item.getSize(); // ϴļĴС
						String fileName = item.getName(); // ȡļ
						// System.out.println("ϴļĴС:" + item.getSize());
						if (upFileSize > maxSize) {
							error = "ϴļ̫ѡ񲻳50Mļ";
							break;
						}
						// ʱļݴڷڴ
						File tempFile = new File(fileName);// ʱ
						// String savePath=tempFile.getName();
						// //ϴļڿͻ˵·
						// request.setAttribute("filename", savePath);
						File file = new File(request.getRealPath("/upload"),
								tempFile.getName()); // ȡĿ¼Ӧʵ·

						InputStream is = item.getInputStream();
						int buffer = 1024; // 建ĴС
						int length = 0;
						byte[] b = new byte[buffer];
						double percent = 0;
						FileOutputStream fos = new FileOutputStream(file);
						while ((length = is.read(b)) != -1) {
							percent += length / (double) upFileSize * 100D; // ϴļİٷֱ
							fos.write(b, 0, length); // ļдȡ
							session.setAttribute("progressBar", Math
									.round(percent)); // ϴٷֱȱ浽Session
						}
						fos.close();
						Thread.sleep(1000); // ߳1
					} else {
						error = "ûѡϴļ";
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			error = "ϴļִ" + e.getMessage();
		}
		if (!"".equals(error)) {
			request.setAttribute("error", error);
			request.getRequestDispatcher("error.jsp")
					.forward(request, response);
		} else {
			request.setAttribute("result", "ļϴɹ");
			request.getRequestDispatcher("upFile_deal.jsp").forward(request,
					response);
		}
	}
}
